# upload\_files\_with\_asset\_builder

`imerit_ango.sdk.SDK.`

## upload\_files\_with\_asset\_builder(project\_id, template\_id, input\_file\_path, priority)

Upload assets to your project using the [asset builder](https://docs.imerit.net/data/importing-assets/asset-builder) template. It processes the CSV file by iterating over each column, generating corresponding assets using the specified template.

### Parameters

* **project\_id:** string
  * The unique identifier for the project. You can find the project ID in [the user interface](/sdk/sdk-documentation.md#project-ids) or retrieve it using the [`list_projects`](/sdk/sdk-documentation/project-level-sdk-functions/list_projects.md) function.
* **template\_id:** string
  * Id of the asset builder template which is created on the AngoHub
  * Example: `'0000000aa0a00a0000aaaa0a'`
* **input\_file\_path:** string
  * The file path of the CSV file
  * Example:
    * `'data_folder/csv_file.csv'`
* **priority:** int, *Optional, default 0*
  * The new priority value to assign to the uploaded assets.
  * **Note:** The priority value must be between -1000 and 1000. Higher values indicate higher priority.

Returns:

* **output:** dict
  * A dictionary containing the result of the operation.
  * Including a `status` field indicating whether the request was successful and a `data` field containing the response payload with updated resources produced by the operation.

{% hint style="info" %}
The maximum asset upload limit is set to 100.000. Please ensure your uploads do not exceed this limit.
{% endhint %}

<details open>

<summary><strong>How to verify in Ango Hub?</strong></summary>

After successfully executing the `upload_files_with_asset_builder` function, you can validate the changes directly in Ango Hub.

Navigate to: **Projects → \[Your Project] → Asset**

* Ensure that all assets have been successfully imported and are visible in the project.

{% hint style="info" %}
Changes made via the SDK are reflected in Ango Hub in near real-time. If updates are not immediately visible, please refresh the page.
{% endhint %}

</details>

### Example

{% tabs %}
{% tab title="python" %}

```python
import os
from dotenv import load_dotenv
from imerit_ango.sdk import SDK

load_dotenv('variables.env')
api_key = os.getenv('API_KEY')
project_id = os.getenv('PROJECT_ID')

ango_sdk = SDK(api_key)

template_id = '<YOUR_TEMPLATE_ID>'
csv_file_path = 'data/my_csv_file.csv'

ango_sdk.upload_files_with_asset_builder(
    project_id=project_id,
    template_id=template_id,
    input_file_path=csv_file_path
)
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
The asset builder template must be correctly configured to match the structure of the CSV file for successful asset generation.
{% endhint %}

{% hint style="info" %}
**See also**

[upload\_files](/sdk/sdk-documentation/project-level-sdk-functions/upload_files.md), [upload\_files\_cloud](/sdk/sdk-documentation/project-level-sdk-functions/upload_files_cloud.md)
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.imerit.net/sdk/sdk-documentation/project-level-sdk-functions/upload_files_with_asset_builder.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
